diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index 1c575e56ff6..95c78116b38 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -109,6 +109,7 @@
 #include "utils/selfuncs.h"
 #include "utils/spccache.h"
 #include "utils/tuplesort.h"
+#include "statistics/statistics.h"
 
 
 #define LOG2(x)  (log(x) / 0.693147180559945)
@@ -5810,6 +5811,7 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 		bool		ref_is_outer;
 		List	   *removedlist;
 		ListCell   *cell;
+		RelOptInfo *ref_rel;
 
 		/*
 		 * This FK is not relevant unless it connects a baserel on one side of
@@ -5937,7 +5939,8 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 		/*
 		 * Finally we get to the payoff: estimate selectivity using the
 		 * knowledge that each referencing row will match exactly one row in
-		 * the referenced table.
+		 * the referenced table.  If join MCV statistics exist for this FK,
+		 * prefer the MCV-based selectivity over the default 1/ref_tuples.
 		 *
 		 * XXX that's not true in the presence of nulls in the referencing
 		 * column(s), so in principle we should derate the estimate for those.
@@ -5957,6 +5960,8 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 		 * work, it is uncommon in practice to have an FK referencing a parent
 		 * table.  So, at least for now, disregard inheritance here.
 		 */
+		ref_rel = find_base_rel(root, fkinfo->ref_relid);
+
 		if (jointype == JOIN_SEMI || jointype == JOIN_ANTI)
 		{
 			/*
@@ -5970,7 +5975,6 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 			 * restriction clauses, which is rows / tuples; but we must guard
 			 * against tuples == 0.
 			 */
-			RelOptInfo *ref_rel = find_base_rel(root, fkinfo->ref_relid);
 			double		ref_tuples = Max(ref_rel->tuples, 1.0);
 
 			fkselec *= ref_rel->rows / ref_tuples;
@@ -5978,14 +5982,28 @@ get_foreign_key_join_selectivity(PlannerInfo *root,
 		else
 		{
 			/*
-			 * Otherwise, selectivity is exactly 1/referenced-table-size; but
-			 * guard against tuples == 0.  Note we should use the raw table
-			 * tuple count, not any estimate of its filtered or joined size.
+			 * Try the removed FK clause for join MCV stats.  If a stat is
+			 * found for the baserel pair, use its selectivity; otherwise
+			 * fall back to the default FK selectivity
+			 * (1/referenced-table-size) applied once per FK constraint.
+			 *
+			 * XXX Currently join stats support only single-condition joins,
+			 * so skip the MCV lookup for multi-column FKs.
 			 */
-			RelOptInfo *ref_rel = find_base_rel(root, fkinfo->ref_relid);
 			double		ref_tuples = Max(ref_rel->tuples, 1.0);
+			Selectivity mcv_sel = 0.0;
+
+			if (list_length(removedlist) == 1)
+			{
+				RestrictInfo *fk_rinfo = (RestrictInfo *) linitial(removedlist);
 
-			fkselec *= 1.0 / ref_tuples;
+				mcv_sel = join_mcv_clause_selectivity(root, fk_rinfo);
+			}
+
+			if (mcv_sel > 0)
+				fkselec *= mcv_sel;
+			else
+				fkselec *= 1.0 / ref_tuples;
 		}
 
 		/*
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index 7c4be174869..3050f00be29 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1654,7 +1654,9 @@ get_relation_constraints(PlannerInfo *root,
 static void
 get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 							   Oid statOid, bool inh,
-							   Bitmapset *keys, List *exprs)
+							   Bitmapset *keys, List *exprs,
+							   List *joinrels, List *keyattrs,
+							   List *keyrefs, List *joinconds)
 {
 	Form_pg_statistic_ext_data dataForm;
 	HeapTuple	dtup;
@@ -1705,6 +1707,10 @@ get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 		info->kind = STATS_EXT_MCV;
 		info->keys = bms_copy(keys);
 		info->exprs = exprs;
+		info->joinrels = joinrels;
+		info->keyattrs = keyattrs;
+		info->keyrefs = keyrefs;
+		info->joinconds = joinconds;
 
 		*stainfos = lappend(*stainfos, info);
 	}
@@ -1754,6 +1760,12 @@ get_relation_statistics(PlannerInfo *root, RelOptInfo *rel,
 		List	   *exprs = NIL;
 		int			i;
 
+		/* Join statistics fields */
+		List	   *joinrels_list = NIL;
+		List	   *keyattrs_list = NIL;
+		List	   *keyrefs_list = NIL;
+		List	   *joinconds = NIL;
+
 		htup = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(statOid));
 		if (!HeapTupleIsValid(htup))
 			elog(ERROR, "cache lookup failed for statistics object %u", statOid);
@@ -1822,11 +1834,60 @@ get_relation_statistics(PlannerInfo *root, RelOptInfo *rel,
 			}
 		}
 
+		/*
+		 * Get join statistics fields if present.  Join stats have a non-null
+		 * stxjoinrels array listing the other participating relations.
+		 */
+		{
+			bool		isnull;
+			Datum		datum;
+
+			datum = SysCacheGetAttr(STATEXTOID, htup,
+									Anum_pg_statistic_ext_stxjoinrels, &isnull);
+			if (!isnull)
+			{
+				oidvector  *jrels = (oidvector *) DatumGetPointer(datum);
+				int2vector *keyrefs_vec;
+				int			nstxkeys;
+				char	   *condstr;
+
+				for (i = 0; i < jrels->dim1; i++)
+					joinrels_list = lappend_oid(joinrels_list,
+												jrels->values[i]);
+
+				/* stxkeys and stxkeyrefs */
+				nstxkeys = staForm->stxkeys.dim1;
+				datum = SysCacheGetAttrNotNull(STATEXTOID, htup,
+											   Anum_pg_statistic_ext_stxkeyrefs);
+				keyrefs_vec = (int2vector *) DatumGetPointer(datum);
+				for (i = 0; i < nstxkeys; i++)
+				{
+					keyattrs_list = lappend_int(keyattrs_list,
+												staForm->stxkeys.values[i]);
+					keyrefs_list = lappend_int(keyrefs_list,
+											   keyrefs_vec->values[i]);
+				}
+
+				/* stxjoinconds */
+				datum = SysCacheGetAttrNotNull(STATEXTOID, htup,
+											   Anum_pg_statistic_ext_stxjoinconds);
+				condstr = TextDatumGetCString(datum);
+				joinconds = (List *) stringToNode(condstr);
+				pfree(condstr);
+			}
+		}
+
 		/* extract statistics for possible values of stxdinherit flag */
 
-		get_relation_statistics_worker(&stainfos, rel, statOid, true, keys, exprs);
+		get_relation_statistics_worker(&stainfos, rel, statOid, true,
+									   keys, exprs,
+									   joinrels_list, keyattrs_list,
+									   keyrefs_list, joinconds);
 
-		get_relation_statistics_worker(&stainfos, rel, statOid, false, keys, exprs);
+		get_relation_statistics_worker(&stainfos, rel, statOid, false,
+									   keys, exprs,
+									   joinrels_list, keyattrs_list,
+									   keyrefs_list, joinconds);
 
 		ReleaseSysCache(htup);
 		bms_free(keys);
diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index ff4e1388c55..9989ebfd94b 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -4924,6 +4924,13 @@ stats_param:	ColId
 					$$->name = $1;
 					$$->expr = NULL;
 				}
+			| ColId indirection
+				{
+					/* Table-qualified column reference (e.g., tbl.col) */
+					$$ = makeNode(StatsElem);
+					$$->name = NULL;
+					$$->expr = (Node *) makeColumnRef($1, $2, @1, yyscanner);
+				}
 			| func_expr_windowless
 				{
 					$$ = makeNode(StatsElem);
diff --git a/src/backend/parser/parse_utilcmd.c b/src/backend/parser/parse_utilcmd.c
index a049cc67ed6..196d686cd4a 100644
--- a/src/backend/parser/parse_utilcmd.c
+++ b/src/backend/parser/parse_utilcmd.c
@@ -3146,12 +3146,53 @@ transformIndexStmt(Oid relid, IndexStmt *stmt, const char *queryString)
 	return stmt;
 }
 
+/*
+ * flatten_join_tree - recursively flatten a JoinExpr tree
+ *
+ * Opens each RangeVar leaf, adds it to the parser namespace, and appends
+ * the opened Relation to *rels.  Appends each JoinExpr node to *joins.
+ * Both lists are in left-to-right tree order.
+ */
+static void
+flatten_join_tree(ParseState *pstate, Node *node,
+				  List **rels, List **joins)
+{
+	if (IsA(node, RangeVar))
+	{
+		RangeVar   *rv = (RangeVar *) node;
+		Relation	rel;
+		ParseNamespaceItem *nsitem;
+
+		rel = table_openrv(rv, ShareUpdateExclusiveLock);
+		nsitem = addRangeTableEntryForRelation(pstate, rel,
+											   AccessShareLock,
+											   rv->alias, false, true);
+		addNSItemToQuery(pstate, nsitem, false, true, true);
+		*rels = lappend(*rels, rel);
+	}
+	else if (IsA(node, JoinExpr))
+	{
+		JoinExpr   *j = (JoinExpr *) node;
+
+		flatten_join_tree(pstate, j->larg, rels, joins);
+		flatten_join_tree(pstate, j->rarg, rels, joins);
+		*joins = lappend(*joins, j);
+	}
+	else
+		ereport(ERROR,
+				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+				 errmsg("unsupported FROM clause element in join statistics")));
+}
+
 /*
  * transformStatsStmt - parse analysis for CREATE STATISTICS
  *
- * To avoid race conditions, it's important that this function relies only on
- * the passed-in relid (and not on stmt->relation) to determine the target
- * relation.
+ * For single-relation statistics, to avoid race conditions, it's important
+ * that this function relies only on the passed-in relid (and not on
+ * stmt->relation) to determine the target relation.
+ *
+ * For join statistics, relid is InvalidOid and tables are resolved directly
+ * from stmt->relations.
  */
 CreateStatsStmt *
 transformStatsStmt(Oid relid, CreateStatsStmt *stmt, const char *queryString)
@@ -3159,7 +3200,9 @@ transformStatsStmt(Oid relid, CreateStatsStmt *stmt, const char *queryString)
 	ParseState *pstate;
 	ParseNamespaceItem *nsitem;
 	ListCell   *l;
-	Relation	rel;
+	Relation	rel = NULL;
+	bool		isjoin = (stmt->relations != NIL &&
+						  IsA(linitial(stmt->relations), JoinExpr));
 
 	/* Nothing to do if statement already transformed. */
 	if (stmt->transformed)
@@ -3169,18 +3212,128 @@ transformStatsStmt(Oid relid, CreateStatsStmt *stmt, const char *queryString)
 	pstate = make_parsestate(NULL);
 	pstate->p_sourcetext = queryString;
 
-	/*
-	 * Put the parent table into the rtable so that the expressions can refer
-	 * to its fields without qualification.  Caller is responsible for locking
-	 * relation, but we still need to open it.
-	 */
-	rel = relation_open(relid, NoLock);
-	nsitem = addRangeTableEntryForRelation(pstate, rel,
-										   AccessShareLock,
-										   NULL, false, true);
+	if (isjoin)
+	{
+		Node	   *fromNode = (Node *) linitial(stmt->relations);
+		List	   *rels = NIL;
+		List	   *joins = NIL;
+		int			nrels;
 
-	/* no to join list, yes to namespaces */
-	addNSItemToQuery(pstate, nsitem, false, true, true);
+		Assert(IsA(fromNode, JoinExpr));
+
+		/* Collect tables and join nodes from the JoinExpr node */
+		flatten_join_tree(pstate, fromNode, &rels, &joins);
+
+		nrels = list_length(rels);
+		Assert(nrels >= 2);
+
+		/*
+		 * Transform the join quals in each JoinExpr now that all tables are
+		 * in the namespace, and collect them into stmt->stxjoinconds.
+		 */
+		foreach(l, joins)
+		{
+			JoinExpr   *j = (JoinExpr *) lfirst(l);
+
+			if (j->jointype != JOIN_INNER)
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("join statistics are only supported for inner joins")));
+
+			if (j->quals)
+			{
+				j->quals = transformExpr(pstate, j->quals,
+										 EXPR_KIND_JOIN_ON);
+				assign_expr_collations(pstate, j->quals);
+				stmt->stxjoinconds = lappend(stmt->stxjoinconds, j->quals);
+			}
+		}
+
+		/*
+		 * Validate join conditions.  Each qual must be a simple OpExpr with
+		 * Var operands using a mergejoinable equality operator.
+		 */
+		foreach(l, stmt->stxjoinconds)
+		{
+			OpExpr	   *opexpr;
+			Var		   *lvar;
+			Var		   *rvar;
+
+			if (!IsA(lfirst(l), OpExpr))
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("join statistics require a single equality join condition per pair of tables")));
+
+			opexpr = (OpExpr *) lfirst(l);
+
+			if (list_length(opexpr->args) != 2 ||
+				!IsA(linitial(opexpr->args), Var) ||
+				!IsA(lsecond(opexpr->args), Var))
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("join statistics require simple equality join conditions")));
+
+			lvar = (Var *) linitial(opexpr->args);
+			rvar = (Var *) lsecond(opexpr->args);
+
+			if (!AttrNumberIsForUserDefinedAttr(lvar->varattno) ||
+				!AttrNumberIsForUserDefinedAttr(rvar->varattno))
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("join statistics do not support whole-row references in join conditions")));
+
+			if (lvar->varno < 1 || lvar->varno > nrels ||
+				rvar->varno < 1 || rvar->varno > nrels)
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("join condition references invalid relation")));
+
+			if (get_mergejoin_opfamilies(opexpr->opno) == NIL)
+				ereport(ERROR,
+						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+						 errmsg("join statistics require equality join conditions")));
+		}
+
+		/* Reject join stats without any join conditions (e.g. CROSS JOIN) */
+		if (stmt->stxjoinconds == NIL)
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+					 errmsg("join statistics require at least one join condition"),
+					 errhint("Use JOIN ... ON instead of CROSS JOIN.")));
+
+		/*
+		 * Extract resolved table OIDs.  The anchor (stxrelid) is the first
+		 * table in the FROM clause; the rest go to stxjoinrels.
+		 */
+		stmt->stxrelid = RelationGetRelid((Relation) linitial(rels));
+		foreach(l, rels)
+		{
+			Relation	r = (Relation) lfirst(l);
+
+			if (foreach_current_index(l) > 0)
+				stmt->stxjoinrels = lappend_oid(stmt->stxjoinrels,
+												RelationGetRelid(r));
+			table_close(r, NoLock);
+		}
+
+		list_free(rels);
+		list_free(joins);
+	}
+	else
+	{
+		/*
+		 * Put the parent table into the rtable so that the expressions can
+		 * refer to its fields without qualification.  Caller is responsible
+		 * for locking relation, but we still need to open it.
+		 */
+		rel = relation_open(relid, NoLock);
+		nsitem = addRangeTableEntryForRelation(pstate, rel,
+											   AccessShareLock,
+											   NULL, false, true);
+
+		/* no to join list, yes to namespaces */
+		addNSItemToQuery(pstate, nsitem, false, true, true);
+	}
 
 	/* take care of any expressions */
 	foreach(l, stmt->exprs)
@@ -3198,19 +3351,32 @@ transformStatsStmt(Oid relid, CreateStatsStmt *stmt, const char *queryString)
 		}
 	}
 
-	/*
-	 * Check that only the base rel is mentioned.  (This should be dead code
-	 * now that add_missing_from is history.)
-	 */
-	if (list_length(pstate->p_rtable) != 1)
-		ereport(ERROR,
-				(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
-				 errmsg("statistics expressions can refer only to the table being referenced")));
+	if (!isjoin)
+	{
+		/*
+		 * Check that only the base rel is mentioned.  (This should be dead
+		 * code now that add_missing_from is history.)
+		 */
+		if (list_length(pstate->p_rtable) != 1)
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
+					 errmsg("statistics expressions can refer only to the table being referenced")));
 
-	free_parsestate(pstate);
+		/* Close relation */
+		table_close(rel, NoLock);
+	}
+	else
+	{
+		/*
+		 * For extended join stats, we need at least 2 tables in the rtable.
+		 */
+		if (list_length(pstate->p_rtable) < 2)
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_COLUMN_REFERENCE),
+					 errmsg("extended join statistics must reference at least two tables")));
+	}
 
-	/* Close relation */
-	table_close(rel, NoLock);
+	free_parsestate(pstate);
 
 	/* Mark statement as successfully transformed */
 	stmt->transformed = true;
diff --git a/src/backend/statistics/Makefile b/src/backend/statistics/Makefile
index 7ff5938b027..9639e0b95f5 100644
--- a/src/backend/statistics/Makefile
+++ b/src/backend/statistics/Makefile
@@ -17,6 +17,7 @@ OBJS = \
 	dependencies.o \
 	extended_stats.o \
 	extended_stats_funcs.o \
+	join_mcv.o \
 	mcv.o \
 	mvdistinct.o \
 	relation_stats.o \
diff --git a/src/backend/statistics/extended_stats.c b/src/backend/statistics/extended_stats.c
index 2b83355d26e..f9a88a56c9d 100644
--- a/src/backend/statistics/extended_stats.c
+++ b/src/backend/statistics/extended_stats.c
@@ -71,6 +71,20 @@ typedef struct StatExtEntry
 	List	   *types;			/* 'char' list of enabled statistics kinds */
 	int			stattarget;		/* statistics target (-1 for default) */
 	List	   *exprs;			/* expressions */
+
+	/*
+	 * Join statistics fields (NULL/invalid for single-table stats).
+	 *
+	 * For joins, the columns Bitmapset is insufficient because the same
+	 * attnum can appear from different relations.  These arrays preserve the
+	 * full per-column mapping.
+	 */
+	int16	   *attnums;		/* attribute numbers, one per stats column */
+	int			nattnums;		/* length of attnums[] and attref_varnos[] */
+	int16	   *attref_varnos;	/* source relation varno for each attnum */
+	Oid		   *joinrels;		/* other relation OIDs */
+	int			njoinrels;		/* number of other relations */
+	List	   *joinconds;		/* List of OpExpr: join conditions */
 } StatExtEntry;
 
 
@@ -158,6 +172,7 @@ BuildRelationExtStatistics(Relation onerel, bool inh, double totalrows,
 		MCVList    *mcv = NULL;
 		Datum		exprstats = (Datum) 0;
 		VacAttrStats **stats;
+		VacAttrStats **mcv_stats = NULL;
 		ListCell   *lc2;
 		int			stattarget;
 		StatsBuildData *data;
@@ -165,10 +180,12 @@ BuildRelationExtStatistics(Relation onerel, bool inh, double totalrows,
 		/*
 		 * Check if we can build these stats based on the column analyzed. If
 		 * not, report this fact (except in autovacuum) and move on.
+		 *
+		 * For join stats this may return NULL; they are built separately.
 		 */
 		stats = lookup_var_attr_stats(stat->columns, stat->exprs,
 									  natts, vacattrstats);
-		if (!stats)
+		if (!stats && stat->njoinrels == 0)
 		{
 			if (!AmAutoVacuumWorkerProcess())
 				ereport(WARNING,
@@ -181,21 +198,40 @@ BuildRelationExtStatistics(Relation onerel, bool inh, double totalrows,
 			continue;
 		}
 
-		/* compute statistics target for this statistics object */
-		stattarget = statext_compute_stattarget(stat->stattarget,
-												bms_num_members(stat->columns),
-												stats);
+		/* Join stats are built separately later */
+		if (stat->njoinrels > 0)
+		{
+			stattarget = stat->stattarget >= 0 ? stat->stattarget
+				: default_statistics_target;
 
-		/*
-		 * Don't rebuild statistics objects with statistics target set to 0
-		 * (we just leave the existing values around, just like we do for
-		 * regular per-column statistics).
-		 */
-		if (stattarget == 0)
-			continue;
+			/*
+			 * Don't rebuild statistics objects with statistics target set to
+			 * 0 (we just leave the existing values around, just like we do
+			 * for regular per-column statistics).
+			 */
+			if (stattarget == 0)
+				continue;
+
+			data = NULL;
+		}
+		else
+		{
+			/* compute statistics target for this statistics object */
+			stattarget = statext_compute_stattarget(stat->stattarget,
+													bms_num_members(stat->columns),
+													stats);
 
-		/* evaluate expressions (if the statistics object has any) */
-		data = make_build_data(onerel, stat, numrows, rows, stats, stattarget);
+			/*
+			 * Don't rebuild statistics objects with statistics target set to
+			 * 0 (we just leave the existing values around, just like we do
+			 * for regular per-column statistics).
+			 */
+			if (stattarget == 0)
+				continue;
+
+			/* evaluate expressions (if the statistics object has any) */
+			data = make_build_data(onerel, stat, numrows, rows, stats, stattarget);
+		}
 
 		/* compute statistic of each requested type */
 		foreach(lc2, stat->types)
@@ -207,7 +243,78 @@ BuildRelationExtStatistics(Relation onerel, bool inh, double totalrows,
 			else if (t == STATS_EXT_DEPENDENCIES)
 				dependencies = statext_dependencies_build(data);
 			else if (t == STATS_EXT_MCV)
-				mcv = statext_mcv_build(data, totalrows, stattarget);
+			{
+				if (stat->njoinrels > 0)
+				{
+					VacAttrStats **join_mcv_stats = NULL;
+					int16		jleft[INDEX_MAX_KEYS];
+					int16		jright[INDEX_MAX_KEYS];
+					Oid			jops[INDEX_MAX_KEYS];
+					int			njq = 0;
+					ListCell   *jlc;
+
+					/* Warn and skip n-way joins (not yet supported) */
+					if (stat->njoinrels > 1)
+					{
+						ereport(WARNING,
+								(errmsg("join statistics on more than two tables are not yet supported, skipping \"%s\"",
+										stat->name)));
+						break;
+					}
+
+					/*
+					 * Extract flat arrays from joinconds for the build
+					 * function. For n-way (njoinrels > 1) the build function
+					 * will warn and skip.
+					 */
+					foreach(jlc, stat->joinconds)
+					{
+						OpExpr	   *op = (OpExpr *) lfirst(jlc);
+						Var		   *lv = (Var *) linitial(op->args);
+						Var		   *rv = (Var *) lsecond(op->args);
+
+						if (njq >= INDEX_MAX_KEYS)
+							break;
+
+						/*
+						 * Normalize: jleft = sampling side (lower varno),
+						 * jright = indexed/probed side (higher varno).
+						 */
+						if (lv->varno < rv->varno)
+						{
+							jleft[njq] = lv->varattno;
+							jright[njq] = rv->varattno;
+						}
+						else
+						{
+							jleft[njq] = rv->varattno;
+							jright[njq] = lv->varattno;
+						}
+						jops[njq] = op->opno;
+						njq++;
+					}
+
+					mcv = statext_join_mcv_build(
+												 onerel,
+												 stat->joinrels,
+												 stat->njoinrels,
+												 jleft, jright,
+												 jops, njq,
+												 stat->attnums,
+												 stat->attref_varnos,
+												 stat->nattnums,
+												 stattarget,
+												 numrows, rows, totalrows,
+												 &join_mcv_stats);
+					if (join_mcv_stats)
+						mcv_stats = join_mcv_stats;
+				}
+				else
+				{
+					mcv = statext_mcv_build(data, totalrows, stattarget);
+					mcv_stats = stats;
+				}
+			}
 			else if (t == STATS_EXT_EXPRESSIONS)
 			{
 				AnlExprData *exprdata;
@@ -228,7 +335,7 @@ BuildRelationExtStatistics(Relation onerel, bool inh, double totalrows,
 
 		/* store the statistics in the catalog */
 		statext_store(stat->statOid, inh,
-					  ndistinct, dependencies, mcv, exprstats, stats);
+					  ndistinct, dependencies, mcv, exprstats, mcv_stats);
 
 		/* for reporting progress */
 		pgstat_progress_update_param(PROGRESS_ANALYZE_EXT_STATS_COMPUTED,
@@ -546,6 +653,55 @@ fetch_statentries_for_relation(Relation pg_statext, Relation rel)
 
 		entry->exprs = exprs;
 
+		/*
+		 * Fetch join statistics fields.  These are all NULL for single-table
+		 * statistics.
+		 */
+		datum = SysCacheGetAttr(STATEXTOID, htup,
+								Anum_pg_statistic_ext_stxjoinrels, &isnull);
+		if (!isnull)
+		{
+			oidvector  *ov = (oidvector *) DatumGetPointer(datum);
+
+			entry->njoinrels = ov->dim1;
+			entry->joinrels = (Oid *) palloc(ov->dim1 * sizeof(Oid));
+			memcpy(entry->joinrels, ov->values, ov->dim1 * sizeof(Oid));
+
+			entry->nattnums = staForm->stxkeys.dim1;
+			entry->attnums = palloc(entry->nattnums * sizeof(int16));
+			for (i = 0; i < entry->nattnums; i++)
+				entry->attnums[i] = staForm->stxkeys.values[i];
+		}
+		else
+		{
+			entry->njoinrels = 0;
+			entry->joinrels = NULL;
+		}
+
+		datum = SysCacheGetAttr(STATEXTOID, htup,
+								Anum_pg_statistic_ext_stxkeyrefs, &isnull);
+		if (!isnull)
+		{
+			int2vector *iv = (int2vector *) DatumGetPointer(datum);
+
+			entry->attref_varnos = (int16 *) palloc(iv->dim1 * sizeof(int16));
+			memcpy(entry->attref_varnos, iv->values, iv->dim1 * sizeof(int16));
+		}
+		else
+			entry->attref_varnos = NULL;
+
+		datum = SysCacheGetAttr(STATEXTOID, htup,
+								Anum_pg_statistic_ext_stxjoinconds, &isnull);
+		if (!isnull)
+		{
+			char	   *str = TextDatumGetCString(datum);
+
+			entry->joinconds = (List *) stringToNode(str);
+			pfree(str);
+		}
+		else
+			entry->joinconds = NIL;
+
 		result = lappend(result, entry);
 	}
 
@@ -879,7 +1035,7 @@ multi_sort_init(int ndims)
 {
 	MultiSortSupport mss;
 
-	Assert(ndims >= 2);
+	Assert(ndims >= 1);		/* join MCV stats may have a single column */
 
 	mss = (MultiSortSupport) palloc0(offsetof(MultiSortSupportData, ssup)
 									 + sizeof(SortSupportData) * ndims);
@@ -2022,6 +2178,67 @@ statext_mcv_clauselist_selectivity(PlannerInfo *root, List *clauses, int varReli
 	return sel;
 }
 
+/*
+ * statext_join_mcv_clauselist_selectivity
+ *		Estimate join clause selectivity using join MCV statistics.
+ *
+ * Iterates over the clause list and, for each join clause (Var = Var across
+ * different relations), extracts the baserel pair from the Vars and checks
+ * whether a join MCV stat for that pair can provide a better selectivity
+ * estimate.  This per baserel pair approach produces the same result
+ * regardless of which component rel pair is used to form the joinrel,
+ * because it goes directly to the baserels' statlists via Var.varno
+ * rather than inspecting the join tree structure.
+ *
+ * The selectivity for each baserel pair is adjusted to account for filter
+ * correlations: the raw MCV selectivity (P(join AND filter)) is divided by
+ * the filter selectivity (already reflected in base rel rows) to yield
+ * P(join | filter).
+ *
+ * Returns the product of estimated selectivities (1.0 for clauses without
+ * applicable stats).  'estimatedclauses' is populated with the 0-based list
+ * position indexes of clauses estimated here.
+ */
+Selectivity
+statext_join_mcv_clauselist_selectivity(PlannerInfo *root,
+										List *clauses,
+										int varRelid,
+										Bitmapset **estimatedclauses)
+{
+	Selectivity result = 1.0;
+	int			clause_idx = -1;
+	ListCell   *lc;
+
+	foreach(lc, clauses)
+	{
+		RestrictInfo *rinfo;
+		Selectivity selec;
+
+		clause_idx++;
+
+		if (!IsA(lfirst(lc), RestrictInfo))
+			continue;
+
+		rinfo = (RestrictInfo *) lfirst(lc);
+
+		/*
+		 * Skip clauses already estimated (e.g., filter clauses from a prior
+		 * join stat)
+		 */
+		if (bms_is_member(clause_idx, *estimatedclauses))
+			continue;
+
+		selec = join_mcv_clause_selectivity(root, rinfo);
+		if (selec <= 0)
+			continue;
+
+		result *= selec;
+		*estimatedclauses = bms_add_member(*estimatedclauses, clause_idx);
+	}
+
+	return result;
+}
+
 /*
  * statext_clauselist_selectivity
  *		Estimate clauses using the best multi-column statistics.
